/*

 //LOCAL_MACHINE//SYSTEM//CurrentControllerSet/Enum/ (USB|USBSTOR)

http://www.microsoft.com/whdc/system/bus/USB/IAD.mspx

*/

/* Sub Classes  for mass storage devices */

#define MSC_SC_RBC      0x01 /* Reduced Block Commands Flash devices */
#define MSC_SC_8020     0x02 /* ATAPI  CD/DVD drives */
#define MSC_SC_QIC      0x03 /* Tape drives */
#define MSC_SC_UFI      0x04 /* Floppy */
#define MSC_SC_8070     0x05 /* Removeable media */
#define MSC_SC_SCSI     0x06 /* transparent stuff, disk drives */
#define MSC_SC_ISD200   0x07 /* ISD200 ATA stuff */
#define MSC_SC_MAX      SC_ISD200
#define MSC_SC_MIN      SC_RBC

/* map subclass to guid */

/* Class, subclass (0 any), guid */
typedef struct usb_device_map_
{
    const INT class;
    const INT subclass;
    const GUID *devclass;
    const CHAR enumerator[20];
} usb_device_map;

/* 
 * many of these are unknown and untested, 
 * this will need to be extensivly expanded on
 */
static const usb_device_map known_usb_devices[] = 
{
{USB_CLASS_MASS_STORAGE, MSC_SC_8020, &GUID_DEVCLASS_CDROM, "usbstor"},
{USB_CLASS_MASS_STORAGE, MSC_SC_QIC, &GUID_DEVCLASS_TAPEDRIVE, "usbstor"}, 
{USB_CLASS_MASS_STORAGE, MSC_SC_UFI, &GUID_DEVCLASS_FLOPPYDISK, "usbstor"}, 
{USB_CLASS_MASS_STORAGE, MSC_SC_SCSI, &GUID_DEVCLASS_DISKDRIVE, "usbstor"},
{-1,-1,&GUID_DEVCLASS_UNKNOWN,"unknown"}
};

/*
 * This information should go into a mass storage driver
 * and be independed of here... however for now it will reside here.
 *
 * also see the above comment as it also applies here
 */
static const usb_device_map known_msc_interfaces[] = 
{
{USB_CLASS_MASS_STORAGE, MSC_SC_8020, &CdRomClassGuid,"usbstor"}, /*untested*/
{USB_CLASS_MASS_STORAGE, MSC_SC_QIC, &TapeClassGuid,"usbstor"}, /*untested*/
{USB_CLASS_MASS_STORAGE, MSC_SC_UFI, &FloppyClassGuid,"usbstor"}, /*untested*/
{USB_CLASS_MASS_STORAGE, MSC_SC_SCSI, &DiskClassGuid,"usbstor"},
{-1,-1,&GUID_DEVCLASS_UNKNOWN,"unknown"}
};

/* vendor ids */

typedef struct _product_string
{
    WORD id;
    WCHAR string[20];
} usb_product_string;

typedef struct _vendor_string
{
    WORD    id;
    WCHAR    string[12];
    const usb_product_string products[5];
} usb_vendor_string;


/* ALOT needs to be added here */
static const usb_vendor_string usb_vendor_product[] = 
{
    {0x05ac, {'a','p','p','l','e',0}, 
            {
            {0x1201, {'i','p','o','d',0}},
            {0x1202, {'i','p','o','d',0}},
            {0x0,{0}}
            }
    },
    { 0x0,{0},{{0x0,{0}}}}
};
